"""autogenerated by genmsg_py from InterfaceStatus.msg. Do not edit."""
import roslib.message
import struct

import wpa_supplicant_node.msg
import roslib.rostime

class InterfaceStatus(roslib.message.Message):
  _md5sum = "06c40304c1d0cdb57b32ba7783a19554"
  _type = "multi_interface_roam/InterfaceStatus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """int8 STATE_NO_INTERFACE = -1 # The interface does not exist.
int8 STATE_PLUGGED = 0       # The interface exists.
int8 STATE_UP = 1            # The interface is up.
int8 STATE_LINK = 2          # The interface has a link.
int8 STATE_LINK_ADDR = 3     # The interface has a link, and the link has an address.
int8 STATE_ADDR = 4          # The interface has an address.
int8 STATE_PINGING = 5       # Ping packets are making it through.

string pretty_name           # The pretty name of the interface.
string interface             # The name of the interface.
int8 state                   # The state (defined above).
int32 active_interface_rank  # The rank among active interfaces (e.g. 0 for the best active interface) or -1 if inactive
float32 goodness             # How well this interface is sending packets.
float32 reliability          # How reliable this interface is expected to be.
float32 score                # The score use to rank interfaces.
float32 prescore             # The score use to rank interfaces without penalizing radios that are not active.
float32 latency              # Latency of ping packets.
float32 loss                 # Loss of ping packets.
wpa_supplicant_node/Bss bss  # Current BSS (for a wireless network)

================================================================================
MSG: wpa_supplicant_node/Bss
time stamp
string ssid
uint8[6] bssid
int32 frequency # In MHz
int16 beacon_interval
int16 capabilities
int32 quality
int32 noise
int32 level
SecurityProperties wpa
SecurityProperties rsn

#InformationElement []ies
#InformationElement []beacon_ies
# flags
# tsf
# age

================================================================================
MSG: wpa_supplicant_node/SecurityProperties
string[] key_mgmt
string[] group
string[] pairwise

"""
  # Pseudo-constants
  STATE_NO_INTERFACE = -1
  STATE_PLUGGED = 0
  STATE_UP = 1
  STATE_LINK = 2
  STATE_LINK_ADDR = 3
  STATE_ADDR = 4
  STATE_PINGING = 5

  __slots__ = ['pretty_name','interface','state','active_interface_rank','goodness','reliability','score','prescore','latency','loss','bss']
  _slot_types = ['string','string','int8','int32','float32','float32','float32','float32','float32','float32','wpa_supplicant_node/Bss']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       pretty_name,interface,state,active_interface_rank,goodness,reliability,score,prescore,latency,loss,bss
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(InterfaceStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.pretty_name is None:
        self.pretty_name = ''
      if self.interface is None:
        self.interface = ''
      if self.state is None:
        self.state = 0
      if self.active_interface_rank is None:
        self.active_interface_rank = 0
      if self.goodness is None:
        self.goodness = 0.
      if self.reliability is None:
        self.reliability = 0.
      if self.score is None:
        self.score = 0.
      if self.prescore is None:
        self.prescore = 0.
      if self.latency is None:
        self.latency = 0.
      if self.loss is None:
        self.loss = 0.
      if self.bss is None:
        self.bss = wpa_supplicant_node.msg.Bss()
    else:
      self.pretty_name = ''
      self.interface = ''
      self.state = 0
      self.active_interface_rank = 0
      self.goodness = 0.
      self.reliability = 0.
      self.score = 0.
      self.prescore = 0.
      self.latency = 0.
      self.loss = 0.
      self.bss = wpa_supplicant_node.msg.Bss()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self.pretty_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.interface
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_bi6f2I.pack(_x.state, _x.active_interface_rank, _x.goodness, _x.reliability, _x.score, _x.prescore, _x.latency, _x.loss, _x.bss.stamp.secs, _x.bss.stamp.nsecs))
      _x = self.bss.ssid
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.bss.bssid
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_struct_6B.pack(*_x))
      else:
        buff.write(_struct_6s.pack(_x))
      _x = self
      buff.write(_struct_i2h3i.pack(_x.bss.frequency, _x.bss.beacon_interval, _x.bss.capabilities, _x.bss.quality, _x.bss.noise, _x.bss.level))
      length = len(self.bss.wpa.key_mgmt)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.wpa.key_mgmt:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.bss.wpa.group)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.wpa.group:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.bss.wpa.pairwise)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.wpa.pairwise:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.bss.rsn.key_mgmt)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.rsn.key_mgmt:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.bss.rsn.group)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.rsn.group:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.bss.rsn.pairwise)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.rsn.pairwise:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.bss is None:
        self.bss = wpa_supplicant_node.msg.Bss()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.pretty_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.interface = str[start:end]
      _x = self
      start = end
      end += 37
      (_x.state, _x.active_interface_rank, _x.goodness, _x.reliability, _x.score, _x.prescore, _x.latency, _x.loss, _x.bss.stamp.secs, _x.bss.stamp.nsecs,) = _struct_bi6f2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.bss.ssid = str[start:end]
      start = end
      end += 6
      self.bss.bssid = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.bss.frequency, _x.bss.beacon_interval, _x.bss.capabilities, _x.bss.quality, _x.bss.noise, _x.bss.level,) = _struct_i2h3i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.wpa.key_mgmt = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.wpa.key_mgmt.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.wpa.group = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.wpa.group.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.wpa.pairwise = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.wpa.pairwise.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.rsn.key_mgmt = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.rsn.key_mgmt.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.rsn.group = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.rsn.group.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.rsn.pairwise = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.rsn.pairwise.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self.pretty_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.interface
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_bi6f2I.pack(_x.state, _x.active_interface_rank, _x.goodness, _x.reliability, _x.score, _x.prescore, _x.latency, _x.loss, _x.bss.stamp.secs, _x.bss.stamp.nsecs))
      _x = self.bss.ssid
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.bss.bssid
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_struct_6B.pack(*_x))
      else:
        buff.write(_struct_6s.pack(_x))
      _x = self
      buff.write(_struct_i2h3i.pack(_x.bss.frequency, _x.bss.beacon_interval, _x.bss.capabilities, _x.bss.quality, _x.bss.noise, _x.bss.level))
      length = len(self.bss.wpa.key_mgmt)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.wpa.key_mgmt:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.bss.wpa.group)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.wpa.group:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.bss.wpa.pairwise)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.wpa.pairwise:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.bss.rsn.key_mgmt)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.rsn.key_mgmt:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.bss.rsn.group)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.rsn.group:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.bss.rsn.pairwise)
      buff.write(_struct_I.pack(length))
      for val1 in self.bss.rsn.pairwise:
        length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.bss is None:
        self.bss = wpa_supplicant_node.msg.Bss()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.pretty_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.interface = str[start:end]
      _x = self
      start = end
      end += 37
      (_x.state, _x.active_interface_rank, _x.goodness, _x.reliability, _x.score, _x.prescore, _x.latency, _x.loss, _x.bss.stamp.secs, _x.bss.stamp.nsecs,) = _struct_bi6f2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.bss.ssid = str[start:end]
      start = end
      end += 6
      self.bss.bssid = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.bss.frequency, _x.bss.beacon_interval, _x.bss.capabilities, _x.bss.quality, _x.bss.noise, _x.bss.level,) = _struct_i2h3i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.wpa.key_mgmt = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.wpa.key_mgmt.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.wpa.group = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.wpa.group.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.wpa.pairwise = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.wpa.pairwise.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.rsn.key_mgmt = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.rsn.key_mgmt.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.rsn.group = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.rsn.group.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.bss.rsn.pairwise = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1 = str[start:end]
        self.bss.rsn.pairwise.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_bi6f2I = struct.Struct("<bi6f2I")
_struct_6s = struct.Struct("<6s")
_struct_6B = struct.Struct("<6B")
_struct_i2h3i = struct.Struct("<i2h3i")
