//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the network_traffic_control package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __network_traffic_control__TRAFFICCONTROLCONFIG_H__
#define __network_traffic_control__TRAFFICCONTROLCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace network_traffic_control
{
  class TrafficControlConfigStatics;
  
  class TrafficControlConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(TrafficControlConfig &config, const TrafficControlConfig &max, const TrafficControlConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const TrafficControlConfig &config1, const TrafficControlConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, TrafficControlConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const TrafficControlConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, TrafficControlConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const TrafficControlConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T TrafficControlConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (TrafficControlConfig::* field);

      virtual void clamp(TrafficControlConfig &config, const TrafficControlConfig &max, const TrafficControlConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const TrafficControlConfig &config1, const TrafficControlConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, TrafficControlConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const TrafficControlConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, TrafficControlConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const TrafficControlConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 10 "../cfg/TrafficControl.cfg"
      double bandwidth_egress;
//#line 11 "../cfg/TrafficControl.cfg"
      double latency_egress;
//#line 12 "../cfg/TrafficControl.cfg"
      double loss_egress;
//#line 14 "../cfg/TrafficControl.cfg"
      double bandwidth_ingress;
//#line 15 "../cfg/TrafficControl.cfg"
      double latency_ingress;
//#line 16 "../cfg/TrafficControl.cfg"
      double loss_ingress;
//#line 18 "../cfg/TrafficControl.cfg"
      int packet_size;
//#line 24 "../cfg/TrafficControl.cfg"
      std::string status;
//#line 25 "../cfg/TrafficControl.cfg"
      std::string errmsg;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("TrafficControlConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const TrafficControlConfig &__max__ = __getMax__();
      const TrafficControlConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const TrafficControlConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const TrafficControlConfig &__getDefault__();
    static const TrafficControlConfig &__getMax__();
    static const TrafficControlConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const TrafficControlConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void TrafficControlConfig::ParamDescription<std::string>::clamp(TrafficControlConfig &config, const TrafficControlConfig &max, const TrafficControlConfig &min) const
  {
    return;
  }

  class TrafficControlConfigStatics
  {
    friend class TrafficControlConfig;
    
    TrafficControlConfigStatics()
    {
//#line 10 "../cfg/TrafficControl.cfg"
      __min__.bandwidth_egress = 0.0;
//#line 10 "../cfg/TrafficControl.cfg"
      __max__.bandwidth_egress = 10000000000.0;
//#line 10 "../cfg/TrafficControl.cfg"
      __default__.bandwidth_egress = 0.0;
//#line 10 "../cfg/TrafficControl.cfg"
      __param_descriptions__.push_back(TrafficControlConfig::AbstractParamDescriptionConstPtr(new TrafficControlConfig::ParamDescription<double>("bandwidth_egress", "double", 1, "Egress bandwidth limit (bps)", "", &TrafficControlConfig::bandwidth_egress)));
//#line 11 "../cfg/TrafficControl.cfg"
      __min__.latency_egress = 0.0;
//#line 11 "../cfg/TrafficControl.cfg"
      __max__.latency_egress = 2.0;
//#line 11 "../cfg/TrafficControl.cfg"
      __default__.latency_egress = 0.0;
//#line 11 "../cfg/TrafficControl.cfg"
      __param_descriptions__.push_back(TrafficControlConfig::AbstractParamDescriptionConstPtr(new TrafficControlConfig::ParamDescription<double>("latency_egress", "double", 1, "Egress latency (s)", "", &TrafficControlConfig::latency_egress)));
//#line 12 "../cfg/TrafficControl.cfg"
      __min__.loss_egress = 0.0;
//#line 12 "../cfg/TrafficControl.cfg"
      __max__.loss_egress = 100.0;
//#line 12 "../cfg/TrafficControl.cfg"
      __default__.loss_egress = 0.0;
//#line 12 "../cfg/TrafficControl.cfg"
      __param_descriptions__.push_back(TrafficControlConfig::AbstractParamDescriptionConstPtr(new TrafficControlConfig::ParamDescription<double>("loss_egress", "double", 1, "Egress loss (%)", "", &TrafficControlConfig::loss_egress)));
//#line 14 "../cfg/TrafficControl.cfg"
      __min__.bandwidth_ingress = 0.0;
//#line 14 "../cfg/TrafficControl.cfg"
      __max__.bandwidth_ingress = 10000000000.0;
//#line 14 "../cfg/TrafficControl.cfg"
      __default__.bandwidth_ingress = 0.0;
//#line 14 "../cfg/TrafficControl.cfg"
      __param_descriptions__.push_back(TrafficControlConfig::AbstractParamDescriptionConstPtr(new TrafficControlConfig::ParamDescription<double>("bandwidth_ingress", "double", 2, "Ingress bandwidth limit (bps)", "", &TrafficControlConfig::bandwidth_ingress)));
//#line 15 "../cfg/TrafficControl.cfg"
      __min__.latency_ingress = 0.0;
//#line 15 "../cfg/TrafficControl.cfg"
      __max__.latency_ingress = 2.0;
//#line 15 "../cfg/TrafficControl.cfg"
      __default__.latency_ingress = 0.0;
//#line 15 "../cfg/TrafficControl.cfg"
      __param_descriptions__.push_back(TrafficControlConfig::AbstractParamDescriptionConstPtr(new TrafficControlConfig::ParamDescription<double>("latency_ingress", "double", 2, "Ingress latency (s)", "", &TrafficControlConfig::latency_ingress)));
//#line 16 "../cfg/TrafficControl.cfg"
      __min__.loss_ingress = 0.0;
//#line 16 "../cfg/TrafficControl.cfg"
      __max__.loss_ingress = 100.0;
//#line 16 "../cfg/TrafficControl.cfg"
      __default__.loss_ingress = 0.0;
//#line 16 "../cfg/TrafficControl.cfg"
      __param_descriptions__.push_back(TrafficControlConfig::AbstractParamDescriptionConstPtr(new TrafficControlConfig::ParamDescription<double>("loss_ingress", "double", 2, "Ingress loss (%)", "", &TrafficControlConfig::loss_ingress)));
//#line 18 "../cfg/TrafficControl.cfg"
      __min__.packet_size = 0;
//#line 18 "../cfg/TrafficControl.cfg"
      __max__.packet_size = 65536;
//#line 18 "../cfg/TrafficControl.cfg"
      __default__.packet_size = 1500;
//#line 18 "../cfg/TrafficControl.cfg"
      __param_descriptions__.push_back(TrafficControlConfig::AbstractParamDescriptionConstPtr(new TrafficControlConfig::ParamDescription<int>("packet_size", "int", 4, "Packet size (bytes)", "", &TrafficControlConfig::packet_size)));
//#line 24 "../cfg/TrafficControl.cfg"
      __min__.status = "";
//#line 24 "../cfg/TrafficControl.cfg"
      __max__.status = "";
//#line 24 "../cfg/TrafficControl.cfg"
      __default__.status = "OK";
//#line 24 "../cfg/TrafficControl.cfg"
      __param_descriptions__.push_back(TrafficControlConfig::AbstractParamDescriptionConstPtr(new TrafficControlConfig::ParamDescription<std::string>("status", "str", 16, "last operation's status", "{'enum_description': 'Status code', 'enum': [{'srcline': 20, 'description': 'operation successfully completed', 'srcfile': '../cfg/TrafficControl.cfg', 'cconsttype': 'const char * const', 'value': 'OK', 'ctype': 'std::string', 'type': 'str', 'name': 'OK'}, {'srcline': 21, 'description': 'last operation failed', 'srcfile': '../cfg/TrafficControl.cfg', 'cconsttype': 'const char * const', 'value': 'FAIL', 'ctype': 'std::string', 'type': 'str', 'name': 'FAIL'}]}", &TrafficControlConfig::status)));
//#line 25 "../cfg/TrafficControl.cfg"
      __min__.errmsg = "";
//#line 25 "../cfg/TrafficControl.cfg"
      __max__.errmsg = "";
//#line 25 "../cfg/TrafficControl.cfg"
      __default__.errmsg = "";
//#line 25 "../cfg/TrafficControl.cfg"
      __param_descriptions__.push_back(TrafficControlConfig::AbstractParamDescriptionConstPtr(new TrafficControlConfig::ParamDescription<std::string>("errmsg", "str", 16, "error message", "", &TrafficControlConfig::errmsg)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<TrafficControlConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<TrafficControlConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    TrafficControlConfig __max__;
    TrafficControlConfig __min__;
    TrafficControlConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const TrafficControlConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static TrafficControlConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &TrafficControlConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const TrafficControlConfig &TrafficControlConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const TrafficControlConfig &TrafficControlConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const TrafficControlConfig &TrafficControlConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<TrafficControlConfig::AbstractParamDescriptionConstPtr> &TrafficControlConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const TrafficControlConfigStatics *TrafficControlConfig::__get_statics__()
  {
    const static TrafficControlConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = TrafficControlConfigStatics::get_instance();
    
    return statics;
  }

//#line 20 "../cfg/TrafficControl.cfg"
      const char * const TrafficControl_OK = "OK";
//#line 21 "../cfg/TrafficControl.cfg"
      const char * const TrafficControl_FAIL = "FAIL";
}

#endif // __TRAFFICCONTROLRECONFIGURATOR_H__
